// First attempt at timing the sort algorithm
#include "stdafx.h"
#include <cmath>
#include <cstdlib>
#include <ctime>
#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int main()
{
	cout << "Timing the sort algorithm."
		<< endl;
	
	unsigned int N;
	unsigned int reps;
	int count;
	unsigned int k;

	cout << "Input vector size and number of repetitions: ";
	cin >> N >> reps;

	vector<double> A;
	vector<double> B;



	srand(time(0));

	for (unsigned int i = 0; i < N; ++i)
		A.push_back((double)rand());

	B.resize(N);


	vector<long> iterations;
	iterations.reserve(reps);
	
	time_t start, finish;

	cout << "Wait..." << endl;

	start = time(0);
	while (iterations.size() < reps) 
	{
		count = 0;
		do
		{
			++count;
			copy(A.begin(), A.end(), B.begin());
			sort(B.begin(), B.end());
			finish = time(0);
		}
			// Continue as long as clock hasn't ticked:
		while (finish == start);

			// Record the number of iterations:
		iterations.push_back(count);
		start = finish;
	}
	cout << "\nIteration counts: " << endl;
	for (k = 0; k < iterations.size(); ++k) 
		cout << iterations[k] << " ";
	cout << endl;
	
	cout << "\nSorted iteration counts: " << endl;
	sort(iterations.begin(), iterations.end());
	for (k = 0; k < iterations.size(); ++k) 
		cout << iterations[k] << " ";
	cout << endl;
	
	cout << "\nSelected value: " << iterations[reps/2] << endl;
	
	cout << "Time: " << 1000.0/iterations[reps/2]
		<< " ms " << endl << endl;
	
	return 0;
}
