// Define a structure, PS, and some related functions for holding 
// pairs of strings
#include <functional>
using namespace std;

/*
template<class Type1, class Type2>
   struct pair 
   {
	   typedef Type1 first_type;
	   typedef Type2 second_type;

	   Type1 first;
	   Type2 second;

	   pair( );
	   pair(const Type1& Val1, const Type2& Val2);
);
*/

class PS : public pair<string, string>
{
public:
  PS() : pair<string, string> ( ) 
  { }
  PS(const string& s) : pair<string, string>(s, s) 
  {
    sort(first.begin(), first.end());
  }
  operator string() const { return second; }
};

/*
template<class Arg1, class Arg2, class Result>
   struct binary_function 
   {
      typedef Arg1 first_argument_type;
      typedef Arg2 second_argument_type;
      typedef Result result_type;
   };
*/

class FirstLess : public binary_function<PS, PS, bool> 
{
public:
  bool operator()(const PS& p, const PS& q) const 
  { 
    return p.first < q.first; 
  }
} firstLess;

class FirstEqual : public binary_function<PS, PS, bool> 
{
public:
  bool operator()(const PS& p, const PS& q) const 
  { 
    return p.first == q.first; 
  }
} firstEqual;
